#include "stddef.gdh"
// Javanese Script
// Graphite Description Language (GDL) Table
//
// Author: Putu Wiramaswara Widya <info@wirama.web.id>
// Licensed under GNU General Public License v2.0
// See COPYING for more information
//

table(glyph)
// Glyph Definition
// Define all of Javanese script Character
// Based from Unicode Standard version 5.2
// Code Chart can be downloaded from http://www.unicode.org/charts/PDF/UA980.pdf
//
// Various sign (U+A980 - U+A983)
// Glyph that doesn't included in Font are commented
//	gArdachandra = U+A980;
	gAnusvara = U+A981;
	gRepha = U+A982;
	gVisagra = U+A983;
// Letter (U+A984 - U+A9B2)
	gA = U+A984;
	//gI_kawi = U+A985;
	gI = U+A986;
	//gII = U+A987;
	gU = U+A988;
	gR = U+A989;
	gL = U+A98A;
	//gLL = U+A98B;
	gE = U+A98C;
	//gAI = U+A98D;
	gO = U+A98E;
	gKa = U+A98F;
	//gQa = U+A990;
	gKha = U+A991;
	gGa = U+A992;
	gGha = U+A993;
	gNga = U+A994;
	gCa = U+A995;
	//gCha = U+A996;
	gJa = U+A997;
	gJha = U+A998;
	gNya = U+A99A;
	gTta = U+A99B;
	//gTTha = U+A99C;
	//gDda = U+A99D;
	//gDdha = U+A99E;
	gNna = U+A99F;
	gTa = U+A9A0;
	gTha = U+A9A1;
	gDa = U+A9A2;
	gDha = U+A9A3;
	gNa = U+A9A4;
	gPa = U+A9A5;
	gPha = U+A9A6;
	gBa = U+A9A7;
	gBha = U+A9A8;
	gMa = U+A9A9;
	gYa = U+A9AA;
	gRa = U+A9AB;
	//gRa_Agung = U+A9AC;
	gLa = U+A9AD;
	gWa = U+A9AE;
	gSha = U+A9AF;
	//gSsa = U+A9B0;
	gSa = U+A9B1;
	gHa = U+A9B2;
// Sign (U+A9B3 - U+A9BC)
	gNukta = U+A9B3;
	gVowelAA = U+A9B4;
	gVowelO = U+A9B5;
	gVowelI = U+A9B6;
	gVowelII = U+A9B7;
	gVowelU = U+A9B8;
	gVowelUU = U+A9B9;
	gVowelE = U+A9BA;
	gVowelAI = U+A9BB;
	gVowelAE = U+A9BC;
// Virama sign
	gVirama = U+A9C0;
// SOME Puncuation
	gDanda = U+A9C8;
	gDoubleDanda = U+A9C9;
	gColon = U+A9C7;
// Dependent Consonant Sign (U+A9BD - U+A9BF)
	gDepR = U+A9BD;
	gDepRa = U+A9BF;
	gDepYa = U+A9BE;
// Conjunction form
	gConjR = postscript("uniA989_conj");
	gConjL = postscript("uniA98A_conj");
	//gConjLL = postscript("uniA98B_conj");
	gConjKa = postscript("uniA98F_conj");
	//gConjQa = postscript("uniA990_conj");
	gConjKha = postscript("uniA991_conj");
	gConjGa = postscript("uniA992_conj");
	gConjGha = postscript("uniA993_conj");
	gConjNga = postscript("uniA994_conj");
	gConjCa = postscript("uniA995_conj");
	//gConjCha = postscript("uniA996_conj");
	gConjJa = postscript("uniA997_conj");
	gConjJha = postscript("uniA998_conj");
	gConjNya = postscript("uniA99A_conj");
	gConjTta = postscript("uniA99B_conj");
	//gConjTTha = postscript("uniA99C_conj");
	//gConjDda = postscript("uniA99D_conj");
	//gConjDdha = postscript("uniA99E_conj");
	gConjNna = postscript("uniA99F_conj");
	gConjTa = postscript("uniA9A0_conj");
	gConjTha = postscript("uniA9A1_conj");
	gConjDa = postscript("uniA9A2_conj");
	gConjDha = postscript("uniA9A3_conj");
	gConjNa = postscript("uniA9A4_conj");
	gConjPa = postscript("uniA9A5_conj");
	gConjPha = postscript("uniA9A6_conj");
	gConjBa = postscript("uniA9A7_conj");
	gConjBha = postscript("uniA9A8_conj");
	gConjMa = postscript("uniA9A9_conj");
	gConjYa = postscript("uniA9AA_conj");
	gConjRa = postscript("uniA9AB_conj");
	//gConjRa_Agung = postscript("uniA9AC_conj");
	gConjLa = postscript("uniA9AD_conj");
	gConjWa = postscript("uniA9AE_conj");
	gConjSha = postscript("uniA9AF_conj");
	//gConjSsa = postscript("uniA9B0_conj");
	gConjSa = postscript("uniA9B1_conj");
	gConjHa = postscript("uniA9B2_conj");
	gConjDepR = postscript("uniA9BD_conj");
	gConjDepRa = postscript("uniA9BF_conj");
	gConjDepYa = postscript("uniA9BE_conj");
	gConjU = postscript("uniA9B8_conj");
	gConjUU = postscript("uniA9B9_conj");
// Diacritic vowel conjunction
	gVowelIAnusvara = postscript("uniA9B6_A981");
	gVowelINukta = postscript("uniA9B3_A9B6");
	gNuktaRepha = postscript("uniA9B3_A982");
	gVowelINuktaAnusvara = postscript("uniA9B3_A9B6_A981");
	gVowelINuktaRepha = postscript("uniA9B3_A9B6_A982");
	gNuktaAnusvara = postscript("uniA9B3_A981");

// Some Ligature
	gLigConjWu = postscript("uniA9AE_A9B8_conj");
	gLigConjNu = postscript("uniA9A4_A9B8_conj");
	gLigConjNra = postscript("uniA9A4_A9BF_conj");
	gligConjNr = postscript("uniA9A4_A9BD_conj");
// Other
	gSpace = postscript("space");
	gQuestion = postscript("question");
	gParenLeft = postscript("parenleft");
	gParenRight = postscript("parenright");
// Glyph classes
// All Consonant
//	cConsAll = (gKa, gQa, gKha, gGa, gGha, gNga, gCa, gCha, gJa, gJha, gNya, gTta, gTtha, gDda, gDdha, gNna, gTa, gTha, gDa, gDha, gNa, gPa, gPha, gBa, gBha, gMa, gYa, gRa, gRa_Agung, gLa, gWa, gSha, gSsa, gSa, gHa);
//	cConsConjAll = (gConjKa, gConjQa, gConjKha, gConjGa, gConjGha, gConjNga, gConjCa, gConjCha, gConjJa, gConjJha, gConjNya, gConjTta, gConjTtha, gConjDda, gConjDdha, gConjNna, gConjTa, gConjTha, gConjDa, gConjDha, gConjNa, gConjPa, gConjPha, gConjBa, gConjBha, gConjMa, gConjYa, gConjRa, gConjRa_Agung, gConjLa, gConjWa, gConjSha, gConjSsa, gConjSa, gConjHa);

	cConsAll = (gR, gL, gKa, gKha, gGa, gGha, gNga, gCa, gJa, gJha, gNya, gTta, gNna, gTa, gTha, gDa, gDha, gNa, gPa, gPha, gBa, gBha, gMa, gYa, gRa, gLa, gWa, gSha, gSa, gHa);
	cConsConj = (gConjR, gConjL, gConjKa, gConjKha, gConjGa, gConjGha, gConjNga, gConjCa, gConjJa, gConjJha, gConjNya, gConjTta, gConjNna, gConjTa, gConjTha, gConjDa, gConjDha, gConjNa, gConjPa, gConjPha, gConjBa, gConjBha, gConjMa, gConjYa, gConjRa, gConjLa, gConjWa, gConjSha, gConjSa, gConjHa);
	cConsRaYa = (gR, gRa, gYa);
	cConsConjRaYa = (gConjR, gConjRa, gConjYa);
	cConsNotRaYa = (gL, gKa, gKha, gGa, gGha, gNga, gCa, gJa, gJha, gNya, gTta, gNna, gTa, gTha, gDa, gDha, gNa, gPa, gPha, gBa, gBha, gMa, gLa, gWa, gSha, gSa, gHa);
	cConsConjNotRaYa = (gConjL, gConjKa, gConjKha, gConjGa, gConjGha, gConjNga, gConjCa, gConjJa, gConjJha, gConjNya, gConjTta, gConjNna, gConjTa, gConjTha, gConjDa, gConjDha, gConjNa, gConjPa, gConjPha, gConjBa, gConjBha, gConjMa, gConjLa, gConjWa, gConjSha, gConjSa, gConjHa);
	cConsHaPaPhaSa = (gHa, gPa, gPha, gSa);
	cConsConjHaPaPhaSa = (gConjHa, gConjPa, gConjPha, gConjSa);
	cConsNotHaPaPhaSa = (gR, gL, gKa, gKha, gGa, gGha, gNga, gCa, gJa, gJha, gNya, gTta, gNna, gTa, gTha, gDa, gDha, gNa, gBa, gBha, gMa, gYa, gRa, gLa, gWa, gSha);
	cConsConjNotHaPaPhaSa = (gConjR, gConjL, gConjKa, gConjKha, gConjGa, gConjGha, gConjNga, gConjCa, gConjJa, gConjJha, gConjNya, gConjTta, gConjNna, gConjTa, gConjTha, gConjDa, gConjDha, gConjNa, gConjBa, gConjBha, gConjMa, gConjYa, gConjRa, gConjLa, gConjWa, gConjSha);
	cConsNotNgaHa = (gR, gL, gKa, gKha, gGa, gGha, gCa, gJa, gJha, gNya, gTta, gNna, gTa, gTha, gDa, gDha, gNa, gPa, gPha, gBa, gBha, gMa, gYa, gRa, gLa, gWa, gSha, gSa);
	cConsDepend = (gDepR, gDepRa, gDepYa);
	cConsConjDepend = (gConjDepR, gConjDepRa, gConjDepYa);	
	cVowel = (gVowelAA, gVowelI, gVowelII, gVowelU, gVowelUU, gVowelE, gVowelAE, gVowelAI, gVowelO);
	cOther = (gSpace, gQuestion, gParenLeft, gParenRight, gDanda, gDoubleDanda, gColon);	
	cAll = (cConsAll, cVowel, cOther);
	cConsVowelSpace = (cConsAll, cVowel, gSpace);
	cWulu = (gVowelI, gVowelII);
	cSuku = (gVowelU, gVowelUU);
	cSukuConj = (gConjU, gConjUU);
	cTaling = (gVowelE, gVowelAI);
endtable;

table (substitution)
	//Pass 1, Ng, h, r consonant contextual form
	pass(1)
		gNga gVirama cOther > gAnusvara @3 _;
		gHa gVirama cOther > gVisagra @3 _;
		cConsNotNgaHa gVirama gSpace cConsNotNgaHa > @1 @2 @4 _;		
		cConsAll gVirama gSpace cConsRaYa > @1 @2 @4 _;
		cConsVowelSpace gRa gVirama cConsNotRaYa> @1 gRepha @4 _;
	endpass;	
	//Pass 2, Conjunction form	
	pass(2)
		cConsAll gVirama cConsNotRaYa > @1 cConsConjNotRaYa$3 _ ;
		cConsAll gVirama cConsRaYa > @1 cConsConjRaYa$3 _;
		cConsAll gVirama cConsNotHaPaPhaSa gVirama cConsDepend > @1 cConsConjNotHaPaPhaSa$3 cConsConjDepend$5 _ _ ;
		cConsAll gVirama cConsNotHaPaPhaSa gVirama cConsNotRaYa > @1 @2 @3 cConsConjNotRaYa$5 _ ;
		cConsAll gVirama cConsHaPaPhaSa gVirama cConsNotRaYa > @1 cConsConjHaPaPhaSa$3 cConsNotRaYa$5 _ _;
		cConsAll gVirama cConsHaPaPhaSa gVirama cConsNotRaYa gVirama cConsDepend > @1 cConsConjHaPaPhaSa$3 cConsConj$5 cConsConjDepend$7 _ _ _ ;
	endpass;
	//Pass 3, Consonant + Taling Tedung	
	pass(3)
		cConsAll cTaling > cTaling$2 @1;
		cConsAll gVowelO _ > gVowelE @1 gVowelAA;
		cConsConjHaPaPhaSa cTaling > cTaling$2 @1;
		cConsConjNotHaPaPhaSa gVowelO _ > gVowelE @1 gVowelAA;
		cConsDepend cTaling > cTaling$2 @1;
		cConsDepend gVowelO _ > gVowelE @1 gVowelAA;
	endpass;

	//Pass 4, Consonant + Conjunction + Taling Tedung
	pass(4)	
		cConsAll cTaling cConsConj > @2 @1 @3;
		cConsAll gVowelE cConsConj gVowelAA > @2 @1 @3 @4;

		cConsAll cTaling cConsDepend > @2 @1 @3;
		cConsAll gVowelE cConsDepend gVowelAA > @2 @1 @3 @4;

		cConsAll cConsConjHaPaPhaSa cTaling cConsConj > @3 @1 @2 @4;
		cConsAll cConsConjHaPaPhaSa gVowelE cConsConj gVowelAA > @3 @1 @2 @4 @5;

		cConsAll cConsConj cTaling cConsConjDepend  > @3 @1 @2 @4;
		cConsAll cConsConj gVowelE cConsConjDepend gVowelAA > @3 @1 @2 @4 @5;

		cConsAll cTaling cConsConjHaPaPhaSa > @2 @1 @3;
		cConsAll gVowelE cConsConjHaPaPhaSa gVowelO > @2 @1 @3 @4; 

		cConsAll cConsConjHaPaPhaSa cConsConj cTaling cConsDepend > @4 @1 @2 @3 @5;
		cConsAll cConsConjHaPaPhaSa cConsConj gVowelE cConsDepend gVowelAA > @4 @1 @2 @3 @5 @6;
	endpass;
	//Pass 5, Consonant + Conjunction + Suku
	pass(5)		
		cConsNotHaPaPhaSa cSuku > @1 cSukuConj$2;
		cConsDepend cSuku > @1 cSukuConj$2;
	endpass;
endtable;

table(lb)
	cConsAll { break = BREAK_WORD } cConsAll;
endtable;

